/*------------------------------------------------------------------------------
*
*	Half-Life JailBreak Revision Log
*
*	$History: jailbreak_gamerules.cpp $
*       
*       *****************  Version 36  *****************
*       User: Tim Smith    Date: 5/01/99    Time: 2:52p
*       Updated in $/HLJB/dlls
*       1) Corrected problem with user logging in again
*       2) Added resetangles command
*       3) Improved the players command
*       
*       *****************  Version 35  *****************
*       User: Tim Smith    Date: 4/27/99    Time: 4:06p
*       Updated in $/HLJB/dlls
*       Changed messages to read 'x team' instead of 'team x'
*       
*       *****************  Version 34  *****************
*       User: Tim Smith    Date: 4/27/99    Time: 2:05p
*       Updated in $/HLJB/dlls
*       Changed the name of the trigger_jail_execute to jail_execute.
*       
*       *****************  Version 33  *****************
*       User: Tim Smith    Date: 4/27/99    Time: 10:08a
*       Updated in $/HLJB/dlls
*       Added team based scoring system
*       
*       *****************  Version 32  *****************
*       User: Tim Smith    Date: 4/26/99    Time: 2:52p
*       Updated in $/HLJB/dlls
*       Cleaned up the change team/team assigned messages.
*       
*       *****************  Version 31  *****************
*       User: Tim Smith    Date: 4/26/99    Time: 1:11p
*       Updated in $/HLJB/dlls
*       1) When the initial team selection menu is displayed, the observer is
*       frozen
*       2) Observers will try to spawn at info_intermission entities first
*       
*       *****************  Version 30  *****************
*       User: Tim Smith    Date: 4/25/99    Time: 7:01p
*       Updated in $/HLJB/dlls
*       Updated scoring system to bring it inline with 2.3a
*       
*       *****************  Version 29  *****************
*       User: Tim Smith    Date: 4/25/99    Time: 10:27a
*       Updated in $/HLJB/dlls
*       1) Changed radio text to match the sounds
*       2) Added the execution sound support
*       
*       *****************  Version 28  *****************
*       User: Tim Smith    Date: 4/23/99    Time: 11:02p
*       Updated in $/HLJB/dlls
*       Added support for Haak's gas execution.  This includes the
*       jail_team_master entity and the mastering of the env_fade entity.
*       
*       *****************  Version 27  *****************
*       User: Tim Smith    Date: 4/23/99    Time: 12:11p
*       Updated in $/HLJB/dlls
*       Corrected minor error in an ASSERT for debug.
*       
*       *****************  Version 26  *****************
*       User: Tim Smith    Date: 4/23/99    Time: 10:26a
*       Updated in $/HLJB/dlls
*       Added server config variables to the voting system and cleaned up some
*       code.
*       
*       *****************  Version 25  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 10:27p
*       Updated in $/HLJB/dlls
*       Improved the look of the players command, but since it is a variable
*       width font, it still looks bad.
*       
*       *****************  Version 24  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 9:48p
*       Updated in $/HLJB/dlls
*       Initial version of voting system completed
*       
*       *****************  Version 23  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 11:33a
*       Updated in $/HLJB/dlls
*       Added the players command
*       
*       *****************  Version 22  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 10:57a
*       Updated in $/HLJB/dlls
*       Corrected crash when the team with the fewest players is selected from
*       the menu
*       
*       *****************  Version 21  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 10:47a
*       Updated in $/HLJB/dlls
*       Kludged in the MOTD support so it doesn't conflict with the initial
*       team selection menu.
*       
*       *****************  Version 20  *****************
*       User: Tim Smith    Date: 4/22/99    Time: 9:42a
*       Updated in $/HLJB/dlls
*       1st time initialization is now properly handled in PutInServer...
*       
*       *****************  Version 19  *****************
*       User: Tim Smith    Date: 4/21/99    Time: 10:11a
*       Updated in $/HLJB/dlls
*       1) Players who exit should no longer be counted as members of a team.
*       The free flag on the entity was not being set by the engine.  The team
*       value is not being cleared.
*       2) Players will now start off the with 9mm. (That one is for you Haak)
*       3) Players will teleport after an execution of the other team.  Not be
*       killed.
*       
*       *****************  Version 18  *****************
*       User: Tim Smith    Date: 4/20/99    Time: 12:56p
*       Updated in $/HLJB/dlls
*       1) Team colors are now working.
*       2) Model names have been changed from grunt/recon to red/blue
*       
*       *****************  Version 17  *****************
*       User: Tim Smith    Date: 4/19/99    Time: 7:44p
*       Updated in $/HLJB/dlls
*       Players are now respawned after execution of other team
*       
*       *****************  Version 16  *****************
*       User: Tim Smith    Date: 4/18/99    Time: 8:28p
*       Updated in $/HLJB/dlls
*       Radio information is now table driven
*       
*       *****************  Version 15  *****************
*       User: Tim Smith    Date: 4/16/99    Time: 11:17p
*       Updated in $/HLJB/dlls
*       When a player changes teams, his score is cleared.
*       
*       *****************  Version 14  *****************
*       User: Tim Smith    Date: 4/16/99    Time: 11:59a
*       Updated in $/HLJB/dlls
*       Added the commands RADIO# for the 9 precanned messages.
*       
*       *****************  Version 13  *****************
*       User: Tim Smith    Date: 4/15/99    Time: 3:55p
*       Updated in $/HLJB/dlls
*       1) Corrected bug in the sending of players to jail
*       2) Cleaned up the fraglimit and execution checks
*       
*       *****************  Version 12  *****************
*       User: Tim Smith    Date: 4/15/99    Time: 3:34p
*       Updated in $/HLJB/dlls
*       Totally removed the subclassing of teamplay_gamerules.
*       jailbreak_gamerules is now a subclass of multiplay_gamerules.
*       
*       *****************  Version 11  *****************
*       User: Tim Smith    Date: 4/15/99    Time: 1:40p
*       Updated in $/HLJB/dlls
*       Modified to prevent people from changing teams while in jail
*       
*       *****************  Version 10  *****************
*       User: Tim Smith    Date: 4/15/99    Time: 12:56p
*       Updated in $/HLJB/dlls
*       1) Added player id.
*       2) Corrected bug that allowed you to move around after being executed
*       3) Corrected bug that prevented forcerespawn if a button was held
*       
*       *****************  Version 9  *****************
*       User: Tim Smith    Date: 4/15/99    Time: 9:55a
*       Updated in $/HLJB/dlls
*       Initial version of the HUD completed
*       
*       *****************  Version 8  *****************
*       User: Tim Smith    Date: 4/14/99    Time: 4:12p
*       Updated in $/HLJB/dlls
*       Improved the amount of time it takes for an observer to respawn.  Also
*       reduced the amount of time it takes for a player to auto-respawn.  (was
*       6, now 3 + death animation time)
*       
*       *****************  Version 7  *****************
*       User: Tim Smith    Date: 4/14/99    Time: 3:14p
*       Updated in $/HLJB/dlls
*       Added support for sending players to jail when they are killed
*       
*       *****************  Version 6  *****************
*       User: Tim Smith    Date: 4/14/99    Time: 10:52a
*       Updated in $/HLJB/dlls
*       Modified the team assignments to not use the string, but use the team
*       enum.
*       Added code to set the color of the teams, but there is a problem.
*       
*       *****************  Version 5  *****************
*       User: Tim Smith    Date: 4/13/99    Time: 8:21p
*       Updated in $/HLJB/dlls
*       Modified to remove all items from a player prior to changing teams,
*       being executed, or being released from jail.  The means that the player
*       does not create a weapons box.
*       
*       *****************  Version 4  *****************
*       User: Tim Smith    Date: 4/13/99    Time: 7:50p
*       Updated in $/HLJB/dlls
*       Completed basic jail functions including custom executions.
*       Minor modifications to the radio system.
*       
*       *****************  Version 3  *****************
*       User: Tim Smith    Date: 4/11/99    Time: 3:57p
*       Updated in $/HLJB/dlls
*       Radio system has been added.  This includes flood protection.
*       
*       *****************  Version 2  *****************
*       User: Tim Smith    Date: 4/11/99    Time: 11:24a
*       Updated in $/HLJB/dlls
*       Completed initial implementation of the team selection system
*       
*       *****************  Version 1  *****************
*       User: Tim Smith    Date: 4/10/99    Time: 8:43a
*       Created in $/HLJB/dlls
*       
*-----------------------------------------------------------------------------*/

//
// jailbreak_gamerules.cpp
//

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"player.h"
#include	"weapons.h"
#include	"gamerules.h"
#include	"jailbreak_gamerules.h"
#include	"game.h"

//
// Locals
//

static const char *s_pszObserverTeam = "observer";
static char team_names[MAX_TEAMS][MAX_TEAMNAME_LENGTH];

//
// Class statics
//

int CJailBreakTeamplay::gm_iNumTeams = 0;
int CJailBreakTeamplay::gm_iTeamScores [MAX_TEAMS];

//
// Externals
//

extern DLL_GLOBAL BOOL		g_fGameOver;
extern int gmsgShowMenu;
extern int gmsgJTeamInfo;
extern int gmsgJTeamList;
extern int gmsgSayText;
extern int gmsgDeathMsg;
extern int gmsgGameMode;
extern int gmsgJPlaySound;
extern int gmsgScoreInfo;
extern int gmsgJVoteStatus;
extern int gmsgJTeamScore;
extern int gmsgJInJail;
extern int gmsgJInArmory;

//
// Map list globals
//

int g_nMapCount = 0;
char g_aszMaps [64] [32];
int g_nMapLast = -1;


CJailBreakTeamplay :: CJailBreakTeamplay()
{

	//
	// Force some settings that JailBreak ignores
	//

	CVAR_SET_STRING ("mp_teamplay","1");
//	CVAR_SET_STRING ("mp_teamlist","grunt;recon");
	CVAR_SET_STRING ("mp_teamlist","red;blue");
	CVAR_SET_STRING ("mp_teamoverride","0");

	//
	// Set the execution check time
	//

	m_fExecCheckTime = 0.0f;

	//
	// Initialize data
	//

	m_DisableDeathMessages = FALSE;
	m_DisableDeathPenalty = FALSE;

	//
	// Initialize the team list
	//

	memset( team_names, 0, sizeof(team_names) );
	gm_iNumTeams = 0;

	//
	// Initialize the team scores
	//

	memset (gm_iTeamScores, 0, sizeof (gm_iTeamScores));

	//
	// Set the default teams
	//

	strncpy( m_szTeamList, "red;blue", TEAMPLAY_TEAMLISTLENGTH );
	ParseTeamString();

	//
	// Initialize the voting system
	//

	m_nVote = Vote_None;
}

//=========================================================
// DisplaySelectTeamMenu
// Display the team selection menu
//=========================================================

void CJailBreakTeamplay::DisplaySelectTeamMenu (CBasePlayer *pPlayer, BOOL fNoCancel)
{
	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
	    WRITE_SHORT( fNoCancel ? 0x000F : 0x020F );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING (fNoCancel ? "#Menu_SelectTeam_NoCancel" : "#Menu_SelectTeam");
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_ChangeTeam;
}

//=========================================================
// DisplayRadioMenu
// Display the radio menu
//=========================================================

void CJailBreakTeamplay::DisplayRadioMenu (CBasePlayer *pPlayer)
{
	char szText [256];

	//
	// Generate the text
	//

	int nOption = 1;
	strcpy (szText, "#Menu_Radio_Start\n\n");
	sprintf (szText + strlen (szText), "%d. #Menu_Radio_Sound %s\n",
		++nOption, (pPlayer ->m_nRadioFlags & CBasePlayer::Radio_Sound_Off) ? 
		"#Menu_On" : "#Menu_Off");
	sprintf (szText + strlen (szText), "%d. #Menu_Radio_Text %s\n",
		++nOption, (pPlayer ->m_nRadioFlags & CBasePlayer::Radio_Text_Off) ? 
		"#Menu_On" : "#Menu_Off");
	if (enablenonteamradio .value) 
	{
		sprintf (szText + strlen (szText), "%d. #Menu_Radio_Opponents %s\n",
			++nOption, (pPlayer ->m_nRadioFlags & CBasePlayer::Radio_Opponents_Off) ? 
			"#Menu_On" : "#Menu_Off");
	}
	strcat (szText, "\n#Menu_Cancel\n");
	
	//
	// Compute the option bits
	//

	SHORT uBits = ~ (0xFFFFFFFF << nOption);
	uBits |= 0x200;

	//
	// Send the message to the client
	//

	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( uBits);
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING (szText);
	MESSAGE_END();

	//
	// Remember that we are in a menu
	//

	pPlayer ->m_nMenu = CBasePlayer::Menu_Radio;
}

//=========================================================
// DisplayRadioMessageMenu
// Display the team selection menu
//=========================================================

void CJailBreakTeamplay::DisplayRadioMessageMenu (CBasePlayer *pPlayer)
{
	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( 0x3FF );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING ("#Menu_Radio_Message");
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_RadioMessage;
}

//=========================================================
// DisplayVoteMapMenu
//=========================================================

void CJailBreakTeamplay::DisplayVoteMapMenu (CBasePlayer *pPlayer)
{
	//
	// Refresh the map list
	//

	RefreshMapList (true);

	//
	// Make sure the page is in range
	//

	ASSERT (g_nMapCount >= 1);
	while (pPlayer ->m_nVotePage * 7 >= g_nMapCount)
		pPlayer ->m_nVotePage--;

	//
	// Start the menu string
	//

	char szText [256];
	strcpy (szText, "#Menu_Vote_SelMap\n\n");

	//
	// Add the map names
	//

	int nOption = 0;
	int nStart = pPlayer ->m_nVotePage * 7;
	int nEnd = (pPlayer ->m_nVotePage + 1) * 7;
	for (int i = nStart; i < nEnd && i < g_nMapCount; i++) 
	{
		sprintf (szText + strlen (szText), "%d. %s\n", 
			++nOption, g_aszMaps [i]);
	}
	strcat (szText, "\n");

	//
	// Compute the option bits
	//

	SHORT uBits = ~ (0xFFFFFFFF << nOption);

	//
	// Add the next option
	//

	if (pPlayer ->m_nVotePage * 7 + 7 < g_nMapCount)
	{
		strcat (szText, "#Menu_Vote_Next\n");
		uBits |= 0x080;
	}

	//
	// Add the prev option
	//

	if (pPlayer ->m_nVotePage > 0)
	{
		strcat (szText, "#Menu_Vote_Prev\n");
		uBits |= 0x100;
	}

	//
	// Add the cancel
	//

	strcat (szText, "#Menu_Cancel\n");
	uBits |= 0x200;

	//
	// Send the menu
	//

	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( uBits );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING (szText);
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_VoteMap;
}

//=========================================================
// MenuSelect
// handle the selection of a menu entry
//=========================================================

void CJailBreakTeamplay::BeginVote (CBasePlayer *pPlayer, _Vote nVote, 
									const char *pszVoteText)
{
	//
	// Check for vote in progress
	//

	if (m_nVote != Vote_None)
	{
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "A vote is already in progress\n"));
		return;
	}

	//
	// Save the vote information
	//

	m_nVote = nVote;
	strcpy (m_szVoteText, pszVoteText);
	m_fVoteEndTime = gpGlobals ->time + CVAR_GET_FLOAT (votetime .name);

	//
	// Initialize the votes and update the player's HUD
	//

	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *plr = UTIL_PlayerByIndex( i );
		if (plr)
		{
			CBasePlayer *p = (CBasePlayer *) plr;
			if (p == pPlayer) {
				p ->m_nVote = CBasePlayer::Vote_Yes;
				MESSAGE_BEGIN (MSG_ONE, gmsgJVoteStatus, NULL, p ->edict ());
					WRITE_BYTE (2);
				MESSAGE_END ();
			} else {
				p ->m_nVote = CBasePlayer::Vote_Hasnt;
				MESSAGE_BEGIN (MSG_ONE, gmsgJVoteStatus, NULL, p ->edict ());
					WRITE_BYTE (1);
				MESSAGE_END ();
			}
		}
	}

	//
	// Generate the string
	//

	char szText [256];
	if (m_nVote == Vote_Map)
	{
		sprintf (szText, "* Vote to change map to %s has begun\n",
			m_szVoteText);
	}
	else
	{
		sprintf (szText, "* Vote to ??? has begun\n");
	}
	UTIL_SayTextAll (szText, CBaseEntity::Instance (NULL));
	return;
}


//=========================================================
// MenuSelect
// handle the selection of a menu entry
//=========================================================

BOOL CJailBreakTeamplay::Cmd_MenuSelect (CBasePlayer *pPlayer, const char *pcmd)
{
	char text[1024];

	//
	// Return if no arguments specified
	//

	if ( CMD_ARGC() < 2 )
		return TRUE;

	//
	// Get the menu element that was selected
	//

	int slot = atoi( CMD_ARGV(1) );

	//
	// Save the menu and reset
	//

	CBasePlayer::_Menu nMenu = pPlayer ->m_nMenu;
	pPlayer ->m_nMenu = CBasePlayer::Menu_None;

	//
	// Switch based on the menu
	//

	switch (nMenu) 
	{

		//
		// If it was the change team menu
		//

		case CBasePlayer::Menu_ChangeTeam:
			{

				//
				// Local variables
				//

				const char *pTeamName = NULL;
				CBasePlayer::_Team nTeam;

				//
				// Based on the selected option get the team
				// name and the next team value
				//

				if (slot == 1 || slot == 2)
				{
					nTeam = (CBasePlayer::_Team) (CBasePlayer::Team_Team0 + (slot - 1));
				}
				else if (slot == 3)
				{
					nTeam = (CBasePlayer::_Team) TeamWithFewestPlayers (pPlayer);
				}
				else if (slot == 4)
				{
					nTeam = CBasePlayer::Team_Observe;
				}
				else if (slot == 10)
				{
					nTeam = pPlayer ->m_nTeam;
				}

				//
				// Get the team name
				//

				if (nTeam < 0)
				{
					pTeamName = s_pszObserverTeam;
				}
				else
				{
					pTeamName = GetIndexedTeamName (nTeam);
				}

				//
				// Display the MOTD (done here because the initial 
				// team selection window overrides the MOTD)
				//

				BOOL fFirstTeam = pPlayer ->m_fFirstTeam;
				if (pPlayer ->m_fFirstTeam)
				{
					if (pPlayer ->m_nTeam != nTeam)
					{
						pPlayer ->m_fShowMOTDLatch = TRUE;
					}
					else
					{
						pPlayer ->m_fShowMOTD = TRUE;
					}
					pPlayer ->m_fFirstTeam = FALSE;
				}

				//
				// Do logging
				//

				if (pPlayer ->m_nTeam != nTeam || fFirstTeam)
				{
					//
					// Let the other players know
					//

					if (nTeam == CBasePlayer::Team_Observe)
					{
						sprintf( text, "* %s has become an observer\n", 
							STRING(pPlayer->pev->netname) );
					}
					else if (fFirstTeam)
					{
						sprintf( text, "* %s has joined the \'%s\' team\n", 
							STRING(pPlayer->pev->netname), pTeamName );
					}
					else
					{
						sprintf( text, "* %s has changed to the \'%s\' team\n", 
							STRING(pPlayer->pev->netname), pTeamName );
					}
					UTIL_SayTextAll( text, pPlayer );

					//
					// Log a message
					//

					if (nTeam == CBasePlayer::Team_Observe)
					{
						UTIL_LogPrintf( "\"%s<%i>\" has become an observer\n", 
							STRING( pPlayer->pev->netname ), 
							GETPLAYERUSERID( pPlayer->edict() ), pTeamName );
					}
					else if (fFirstTeam)
					{
						UTIL_LogPrintf( "\"%s<%i>\" joined the %s team\n", 
							STRING( pPlayer->pev->netname ), 
							GETPLAYERUSERID( pPlayer->edict() ), pTeamName );
					}
					else
					{
						UTIL_LogPrintf( "\"%s<%i>\" changed to the %s team\n", 
							STRING( pPlayer->pev->netname ), 
							GETPLAYERUSERID( pPlayer->edict() ), pTeamName );
					}
				}

				//
				// If a new team is being selected
				//

				if (pPlayer ->m_nTeam != nTeam)
				{
					//
					// Enable damage so the change player team code works
					//

					pPlayer ->pev->takedamage = DAMAGE_AIM;

					//
					// Don't drop anything
					//

					pPlayer ->RemoveAllItems (FALSE);

					//
					// Change the team and recount
					//

					pPlayer ->m_nNextTeam = nTeam;
					ChangePlayerTeam (pPlayer, pTeamName, TRUE, 
						(pPlayer ->pev ->flags & FL_SPECTATOR) == 0);
				}

				//
				// If observer, make sure the frozen initial player
				// is cleared
				//
	
				else if (pPlayer ->m_nTeam == CBasePlayer::Team_Observe)
				{
					pPlayer ->pev->movetype = MOVETYPE_NOCLIP;
					pPlayer ->m_afPhysicsFlags &= ~PFLAG_FROZEN;
				}
			}
			break;

		//
		// If it was the radio menu
		//

		case CBasePlayer::Menu_Radio:
			{
				//
				// Adjust slot numbers
				//

				if (slot >= 4 && !enablenonteamradio .value)
					slot++;

				//
				// Process
				//

				if (slot == 1) {
					DisplayRadioMessageMenu (pPlayer);
				} else if (slot == 2) {
					pPlayer ->m_nRadioFlags ^= CBasePlayer::Radio_Sound_Off;
				} else if (slot == 3) {
					pPlayer ->m_nRadioFlags ^= CBasePlayer::Radio_Text_Off;
				} else if (slot == 4) {
					pPlayer ->m_nRadioFlags ^= CBasePlayer::Radio_Opponents_Off;
				} else {
					//cancel
				}
			}
			break;

		//
		// If it was the radio message menu
		//

		case CBasePlayer::Menu_RadioMessage:
			{
				RadioMessage (pPlayer, slot);
			}
			break;

		//
		// If it was the main voting menu
		//

		case CBasePlayer::Menu_VoteMain:
			{
				//
				// Adjust slot numbers
				//

				if (slot >= 1 && CVAR_GET_FLOAT (votemap .name) <= 0)
					slot++;

				//
				// Process the slot
				//

				if (slot == 1) {
					pPlayer ->m_nVotePage = 0;
					DisplayVoteMapMenu (pPlayer);
				}
			}
			break;

		//
		// If it was the map voting menu
		//

		case CBasePlayer::Menu_VoteMap:
			{
				if (slot == 8) {
					pPlayer ->m_nVotePage++;
					DisplayVoteMapMenu (pPlayer);
				} else if (slot == 9) {
					pPlayer ->m_nVotePage--;
					DisplayVoteMapMenu (pPlayer);
				} else if (slot == 10) {
				} else {
					int nMap = pPlayer ->m_nVotePage * 7 + slot - 1;
					BeginVote (pPlayer, Vote_Map, g_aszMaps [nMap]);
				}
			}
			break;

		//
		// If it was the map voting menu
		//

		case CBasePlayer::Menu_VoteCast:
			{
				if (slot == 1) {
					pPlayer ->m_nVote = CBasePlayer::Vote_Yes;
					MESSAGE_BEGIN (MSG_ONE, gmsgJVoteStatus, NULL, pPlayer ->edict ());
						WRITE_BYTE (2);
					MESSAGE_END ();
				} else if (slot == 2) {
					pPlayer ->m_nVote = CBasePlayer::Vote_No;
					MESSAGE_BEGIN (MSG_ONE, gmsgJVoteStatus, NULL, pPlayer ->edict ());
						WRITE_BYTE (3);
					MESSAGE_END ();
				} else {
				}
			}
			break;

		//
		// If it was the menu menu
		//

		case CBasePlayer::Menu_Menu:
			{
				if (slot == 1) {
					Cmd_RadioMenu (pPlayer);
				} else if (slot == 2) {
					Cmd_Vote (pPlayer);
				} else if (slot == 3) {
					Cmd_Help (pPlayer);
				} else if (slot == 4) {
					Cmd_Credits (pPlayer);
				}
			}
			break;

		//
		// If it was a only close menu
		//

		case CBasePlayer::Menu_CloseOnly:
			{
			}
			break;
	}
	return TRUE;
}

//=========================================================
// Cmd_Say
//
// String comes in as
// say blah blah blah
// or as
// blah blah blah
//
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Say (CBasePlayer *pPlayer, BOOL fTeam, BOOL fNoArg0)
{
	char	*p;
	char    szTemp[256];
	const char *pcmd = CMD_ARGV(0);

	// We can get a raw string now, without the "say " prepended
	if ( CMD_ARGC() == 0 )
		return TRUE;

	if ( !fNoArg0 )
	{
		if ( CMD_ARGC() >= 2 )
		{
			p = (char *)CMD_ARGS();
		}
		else
		{
			// say with a blank message, nothing to do
			return TRUE;
		}
	}
	else  // Raw text, need to prepend argv[0]
	{
		if ( CMD_ARGC() >= 2 )
		{
			_snprintf (szTemp, sizeof (szTemp), "%s %s", 
				( char * )pcmd, (char *)CMD_ARGS() );
		}
		else
		{
			// Just a one word command, use the first word...sigh
			_snprintf (szTemp, sizeof (szTemp), "%s", 
				( char * )pcmd );
		}
		szTemp [sizeof (szTemp) - 1] = 0;
		p = szTemp;
	}

// remove quotes if present
	if (*p == '"')
	{
		p++;
		p[strlen(p)-1] = 0;
	}

// make sure the text has content
	for ( char *pc = p; pc != NULL && *pc != 0; pc++ )
	{
		if ( isprint( *pc ) && !isspace( *pc ) )
		{
			pc = NULL;	// we've found an alphanumeric character,  so text is valid
			break;
		}
	}
	if ( pc != NULL )
		return TRUE;  // no character found, so say nothing

// Invoke the helper

	SayPlay (pPlayer, FALSE, fTeam, FALSE, NULL, p);
	return TRUE;
}

//=========================================================
// Cmd_Radio
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Radio (CBasePlayer *pPlayer, BOOL fTeam, BOOL fClose)
{
	char sound [128];
	const char *p, *q;
	int n;

	//
	// If not enough args, return
	//

	if (CMD_ARGC () < 2)
		return TRUE;

	//
	// Get the arguments
	//

	p = CMD_ARGS ();

	//
	// Extract the sound
	//

	for (q = p; *q && *q > ' '; q++);
	n = q - p;
	if (n > sizeof (sound) - 1) n = sizeof (sound) - 1;
	memmove (sound, p, n);
	sound [n] = 0;

	//
	// Locate the start of the text
	//

	for (; *q && *q <= ' '; q++);

	//
	// Invoke the helper
	//

	SayPlay (pPlayer, TRUE, fTeam, fClose, sound, q);
	return TRUE;
}

//=========================================================
// Cmd_RadioSound
//=========================================================

BOOL CJailBreakTeamplay::Cmd_RadioSound (CBasePlayer *pPlayer)
{
	if (FStrEq (CMD_ARGV(1), "1") ||
		FStrEq (CMD_ARGV(1), "on")) {
		pPlayer ->m_nRadioFlags &= ~CBasePlayer::Radio_Sound_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio sound on\n"));
	} else {
		pPlayer ->m_nRadioFlags |= CBasePlayer::Radio_Sound_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio sound off\n"));
	}
	return TRUE;
}

//=========================================================
// Cmd_RadioText
//=========================================================

BOOL CJailBreakTeamplay::Cmd_RadioText (CBasePlayer *pPlayer)
{
	if (FStrEq (CMD_ARGV(1), "1") ||
		FStrEq (CMD_ARGV(1), "on")) {
		pPlayer ->m_nRadioFlags &= ~CBasePlayer::Radio_Text_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio text on\n"));
	} else {
		pPlayer ->m_nRadioFlags |= CBasePlayer::Radio_Text_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio text off\n"));
	}
	return TRUE;
}

//=========================================================
// Cmd_RadioOpponents
//=========================================================

BOOL CJailBreakTeamplay::Cmd_RadioOpponents (CBasePlayer *pPlayer)
{
	if (FStrEq (CMD_ARGV(1), "1") ||
		FStrEq (CMD_ARGV(1), "on")) {
		pPlayer ->m_nRadioFlags &= ~CBasePlayer::Radio_Opponents_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio opponents on\n"));
	} else {
		pPlayer ->m_nRadioFlags |= CBasePlayer::Radio_Opponents_Off;
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "radio opponents off\n"));
	}
	return TRUE;
}

//=========================================================
// Cmd_RadioMenu
//=========================================================

BOOL CJailBreakTeamplay::Cmd_RadioMenu (CBasePlayer *pPlayer)
{
	DisplayRadioMenu (pPlayer);
	return TRUE;
}

//=========================================================
// Cmd_ChangeTeam
// handle the request to change teams
//=========================================================

BOOL CJailBreakTeamplay::Cmd_ChangeTeam (CBasePlayer *pPlayer, const char *pcmd)
{
	if (teamforce .value)
	{
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs("* Not allowed to change teams in this game!\n"));
	}
	else if (pPlayer ->m_nJail != CBasePlayer::Jail_Free)
	{
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs("* You can't changeteams while in jail or waiting execution\n"));
	}
	else
	{
		DisplaySelectTeamMenu (pPlayer, FALSE);
	}
	return TRUE;
}

//=========================================================
// Cmd_ID
//=========================================================

BOOL CJailBreakTeamplay::Cmd_ID (CBasePlayer *pPlayer)
{
	//
	// Set the state
	//

	if (CMD_ARGC () >= 2)
	{
		if (FStrEq (CMD_ARGV(1), "1") ||
			FStrEq (CMD_ARGV(1), "on")) {
			pPlayer ->m_fID = TRUE;
		} 
		else 
		{
			pPlayer ->m_fID = FALSE;
		} 
	}
	else
	{
		pPlayer ->m_fID = !pPlayer ->m_fID;
	}

	//
	// Report the state
	//

	if (pPlayer ->m_fID)
	{
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "player id enabled\n"));
	}
	else
	{
		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs( "player id disable\n"));
	}
	return TRUE;
}

//=========================================================
// Cmd_Players
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Players (CBasePlayer *pPlayer)
{
	ClientPrint (pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs("UserID Kick# Name[team]\n"));
	ClientPrint (pPlayer->pev, HUD_PRINTCONSOLE, 
			UTIL_VarArgs("------ ----- ----------\n"));

	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *plr = UTIL_PlayerByIndex( i );
		if ( plr )
		{
			CBasePlayer *p = (CBasePlayer *) plr;
			if (p ->m_nTeam != CBasePlayer::Team_Disconnected)
			{
				ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
					UTIL_VarArgs("%6d %5d %s[%s]\n",
					GETPLAYERUSERID (p ->edict ()),
					i, STRING (p ->pev ->netname),
					p ->m_szTeamName));
			}
		}
	}
	return TRUE;
}

//=========================================================
// Cmd_Vote
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Vote (CBasePlayer *pPlayer)
{
	//
	// If a vote is already inprogress
	//

	if (m_nVote != Vote_None)
	{
		//
		// Check for already voted
		//

		if (pPlayer ->m_nVote != CBasePlayer::Vote_Hasnt)
		{
			ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
				UTIL_VarArgs( "You have already voted\n"));
			return TRUE;
		}

		//
		// Genate the string
		//

		char szText [256];
		if (m_nVote == Vote_Map)
		{
			sprintf (szText, "Vote to change map to %s#Menu_Vote_YN\n",
				m_szVoteText);
		}
		else
		{
			sprintf (szText, "Vote to ???#Menu_Vote_YN\n\n");
		}

		//
		// Display the menu
		//
		MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
			WRITE_SHORT( 0x0203 );
			WRITE_CHAR( -1 );
			WRITE_BYTE( 0 );
			WRITE_STRING (szText);
		MESSAGE_END();
		pPlayer ->m_nMenu = CBasePlayer::Menu_VoteCast;
	}

	//
	// Otherwise, display the vote selection menu
	//

	else
	{
		char szText [256];

		//
		// Generate the text
		//

		int nOption = 0;
		strcpy (szText, "#Menu_Vote_Main_Start\n\n");
		if (CVAR_GET_FLOAT (votemap .name) > 0)
		{
			sprintf (szText + strlen (szText), "%d. #Menu_Vote_Map_Text\n",
				++nOption);
		}
		strcat (szText, "\n#Menu_Cancel\n");
		
		//
		// If there are no options
		//

		if (nOption == 0)
		{
			ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
				UTIL_VarArgs( "No voting options are enabled on this server\n"));
		}

		//
		// If there are options
		//

		else
		{
			//
			// Compute the option bits
			//

			SHORT uBits = ~ (0xFFFFFFFF << nOption);
			uBits |= 0x200;

			//
			// Send the message to the client
			//

			MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
				WRITE_SHORT( uBits);
				WRITE_CHAR( -1 );
				WRITE_BYTE( 0 );
				WRITE_STRING (szText);
			MESSAGE_END();

			//
			// Remember that we are in a menu
			//

			pPlayer ->m_nMenu = CBasePlayer::Menu_VoteMain;
		}
	}
	return TRUE;
}

//=========================================================
// Cmd_Menu
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Menu (CBasePlayer *pPlayer)
{
	//
	// Display the menu
	//

	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( 0x020F );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING ("#Menu_Menu");
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_Menu;
	return TRUE;
}

//=========================================================
// Cmd_Credits
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Credits (CBasePlayer *pPlayer)
{
	//
	// Display the menu
	//

//	UTIL_ShowMessage ("!Menu_Credits", pPlayer);

	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( 0x0200 );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING ("#Menu_Credits");
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_CloseOnly;

#if 0
	hudtextparms_t	textParms;
	textParms .channel = 0;
	textParms .x = -1;
	textParms .y = -1;
	textParms .effect = 0;
	textParms .r1 = 255;
	textParms .g1 = 255;
	textParms .b1 = 255;
	textParms .a1 = 0;
	textParms .r2 = 240;
	textParms .g2 = 110;
	textParms .b2 = 0;
	textParms .a2 = 0;
	textParms .fadeinTime = 1.5;
	textParms .fadeoutTime = 0.5;
	textParms .holdTime = 5;
	textParms .fxTime = 0.25;
	UTIL_HudMessage( pPlayer, textParms, "#Menu_Credits" );
#endif
	return TRUE;
}

//=========================================================
// Cmd_Help
//=========================================================

BOOL CJailBreakTeamplay::Cmd_Help (CBasePlayer *pPlayer)
{
	//
	// Display the menu
	//

	MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer ->pev);
		WRITE_SHORT( 0x0200 );
		WRITE_CHAR( -1 );
		WRITE_BYTE( 0 );
		WRITE_STRING ("#Menu_Help");
	MESSAGE_END();
	pPlayer ->m_nMenu = CBasePlayer::Menu_CloseOnly;
	return TRUE;
}

//=========================================================
// ClientCommand
// the user has typed a command which is unrecognized by everything else;
// this check to see if the gamerules knows anything about the command
//=========================================================

BOOL CJailBreakTeamplay::ClientCommand( CBasePlayer *pPlayer, const char *pcmd )
{
	if ( FStrEq( pcmd, "menuselect" ) )
	{
		return Cmd_MenuSelect (pPlayer, pcmd);
	}
	else if ( FStrEq (pcmd, "changeteam" ) )
	{
		return Cmd_ChangeTeam (pPlayer, pcmd);
	}
	else if ( FStrEq (pcmd, "say" ) )
	{
		return Cmd_Say (pPlayer, FALSE, FALSE);
	}
	else if ( FStrEq (pcmd, "say_team" ) )
	{
		return Cmd_Say (pPlayer, TRUE, FALSE);
	}
	else if (FStrEq (pcmd, "radio"))
	{
		if (CMD_ARGC () < 2)
		{
			return Cmd_RadioMenu (pPlayer);
		}
		else if (enablenonteamradio .value) 
		{
			return Cmd_Radio (pPlayer, FALSE, FALSE);
		}
		else
		{
			ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
				UTIL_VarArgs("Radio messages to all "
				"players is disabled on this server\n"));
			return TRUE;
		}
	}
	else if (FStrEq (pcmd, "radio_team") ||
		     FStrEq (pcmd, "rteam"))
	{
		return Cmd_Radio (pPlayer, TRUE, FALSE);
	}
	else if (FStrEq (pcmd, "yell"))
	{
		return Cmd_Radio (pPlayer, FALSE, TRUE);
	}
	else if (FStrEq (pcmd, "yell_team") ||
		     FStrEq (pcmd, "yteam"))
	{
		return Cmd_Radio (pPlayer, TRUE, TRUE);
	}
	else if (FStrEq (pcmd, "radio_sound"))
	{
		return Cmd_RadioSound (pPlayer);
	}
	else if (FStrEq (pcmd, "radio_text"))
	{
		return Cmd_RadioText (pPlayer);
	}
	else if (FStrEq (pcmd, "radio_opponents"))
	{
		return Cmd_RadioOpponents (pPlayer);
	}
	else if (FStrEq (pcmd, "radio_menu"))
	{
		return Cmd_RadioMenu (pPlayer);
	}
	else if (FStrEq (pcmd, "freeze"))
	{
		//pPlayer ->pev->takedamage = DAMAGE_NO;
		//pPlayer ->pev->movetype = MOVETYPE_NONE;
		//pPlayer ->m_afPhysicsFlags |= PFLAG_FROZEN;
		//return TRUE;
	}
	else if (FStrEq (pcmd, "unfreeze"))
	{
		//pPlayer ->pev->takedamage = DAMAGE_AIM;
		//pPlayer ->pev->movetype = MOVETYPE_WALK;
		//pPlayer ->m_afPhysicsFlags &= ~PFLAG_FROZEN;
		//return TRUE;
	}
	else if (FStrEq (pcmd, "id"))
	{
		return Cmd_ID (pPlayer);
	}
	else if (FStrEq (pcmd, "execute"))
	{
		//this ->ExecuteTeam (1);
		//return TRUE;
	}
	else if (FStrEq (pcmd, "resetangles"))
	{
		pPlayer->pev->angles .x = pPlayer->pev->v_angle .x;
		pPlayer->pev->angles .z = - pPlayer->pev->angles .z;
		pPlayer->pev->v_angle = g_vecZero;
	    //pPlayer->pev->velocity = pPlayer->pev->basevelocity = g_vecZero;
		//if (pPlayer ->pev->button & IN_MOVELEFT)
		//	CLIENT_COMMAND (pPlayer ->edict (), "-moveleft\n");
		//if (pPlayer ->pev->button & IN_MOVERIGHT)
		//	CLIENT_COMMAND (pPlayer ->edict (), "-moveright\n");
		//pPlayer->pev->button &= ~(IN_MOVELEFT | IN_MOVERIGHT);
		pPlayer->pev->fixangle = TRUE;
		return TRUE;
	}
	else if (FStrEq (pcmd, "players"))
	{
		return Cmd_Players (pPlayer);
	}
	else if (FStrEq (pcmd, "vote"))
	{
		return Cmd_Vote (pPlayer);
	}
	else if (FStrEq (pcmd, "menu"))
	{
		return Cmd_Menu (pPlayer);
	}
	else if (FStrEq (pcmd, "credits"))
	{
		return Cmd_Credits (pPlayer);
	}
	else if (FStrEq (pcmd, "help"))
	{
		return Cmd_Help (pPlayer);
	}
	else
	{
		if (strlen (pcmd) == 6)
		{
			char szText [7];
			strcpy (szText, pcmd);
			szText [5] = 0;
			if (FStrEq (szText, "radio") && isdigit (pcmd [5]) && pcmd [5] != '0')
			{
				RadioMessage (pPlayer, pcmd [5] - '0');
				return TRUE;
			}
		}
	}
	return FALSE;
}

//=========================================================
// PlayerSpawn
//=========================================================

void CJailBreakTeamplay :: PlayerSpawn( CBasePlayer *pPlayer )
{
	if (pPlayer ->m_nTeam >= 0)
	{
		pPlayer->pev->weapons |= (1<<WEAPON_SUIT);
		
		BOOL addDefault = TRUE;
		CBaseEntity	*pWeaponEntity = NULL;
		while ( pWeaponEntity = UTIL_FindEntityByClassname( pWeaponEntity, "game_player_equip" ))
		{
			pWeaponEntity->Touch( pPlayer );
			addDefault = FALSE;
		}

		if ( addDefault )
		{
			pPlayer->GiveNamedItem( "weapon_crowbar" );
			if (!pPlayer ->m_fSpawnInJail)
			{
				pPlayer->GiveNamedItem( "weapon_9mmhandgun" );
				pPlayer->GiveAmmo( 68, "9mm", _9MM_MAX_CARRY );// 4 full reloads
			}
		}
		pPlayer ->m_iHideHUD &= ~(HIDEHUD_WEAPONS | HIDEHUD_FLASHLIGHT | HIDEHUD_HEALTH);
	}
	else
	{
		//should be moved
		pPlayer ->pev->solid = SOLID_NOT;
		pPlayer ->pev->takedamage = DAMAGE_NO;
		pPlayer ->pev->movetype = MOVETYPE_NOCLIP;
		pPlayer ->pev->flags |= FL_SPECTATOR;
		pPlayer ->pev->effects |= EF_NODRAW;
		pPlayer ->m_iHideHUD |= HIDEHUD_WEAPONS | HIDEHUD_FLASHLIGHT | HIDEHUD_HEALTH;
		if (pPlayer ->m_nTeam == CBasePlayer::Team_Menu)
		{
			pPlayer ->pev->movetype = MOVETYPE_NONE;
			pPlayer ->m_afPhysicsFlags |= PFLAG_FROZEN;
		}
	}

	//
	// Set the team colors
	//

	int nColor;
#define DM_COLORED_MODELS
#ifdef DM_COLORED_MODELS
	switch (pPlayer ->m_nTeam) 
	{
		case CBasePlayer::Team_Team0:
			nColor = 1;		// RED
			break;
		case CBasePlayer::Team_Team0 + 1:
			nColor = 171;	// BLUE
			break;
		default:
			nColor = 79;	// GREEN
			break;
	}
#else
	nColor = 0;
#endif
	SetPlayerColor (pPlayer, nColor);
}

//=========================================================
// SetPlayerColor
//=========================================================

void CJailBreakTeamplay :: SetPlayerColor( CBasePlayer *pPlayer, int nColor )
{
	//
	// If the color has changed
	//

	if (pPlayer ->m_nColor != nColor || nColor == -1)
	{
		//
		// Save the new color
		//

		if (nColor != -1) pPlayer ->m_nColor = nColor;

		//
		// Generate the color string
		//

		char szText [32];
		sprintf (szText, "%d", pPlayer ->m_nColor);

		//
		// Set the colors
		//

		int clientIndex = pPlayer->entindex ();
		g_engfuncs.pfnSetClientKeyValue( clientIndex, 
			g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), 
			"topcolor", szText );
		g_engfuncs.pfnSetClientKeyValue( clientIndex, 
			g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), 
			"bottomcolor", szText );
	}
}

//=========================================================
// InitHUD
//=========================================================

void CJailBreakTeamplay :: InitHUD( CBasePlayer *pPlayer )
{
	//
	// Set the team string
	//

	SetDefaultPlayerTeam( pPlayer );

	//
	// Notify other clients of player joining the game
	//

	UTIL_ClientPrintAll ( HUD_PRINTNOTIFY, UTIL_VarArgs( "%s has joined the game\n", 
		( pPlayer->pev->netname && STRING(pPlayer->pev->netname)[0] != 0 ) ? 
		STRING(pPlayer->pev->netname) : "unconnected" ) );

	//
	// Send an entry to the log file
	//

	UTIL_LogPrintf( "\"%s<%i>\" has entered the game\n",  
		STRING( pPlayer->pev->netname ), GETPLAYERUSERID( pPlayer->edict() ) );

	//
	// Send the game mode to the player
	//

	UpdateGameMode( pPlayer );

	//
	// Enable the scoreboard for the player by sending a score
	//

	MESSAGE_BEGIN( MSG_ONE, gmsgScoreInfo, NULL, pPlayer->edict() );
		WRITE_BYTE( ENTINDEX(pPlayer->edict()) );
		WRITE_SHORT( 0 );
		WRITE_SHORT( 0 );
	MESSAGE_END();

	//
	// Loop through all active players and send their score info to the new client
	//

	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		// FIXME:  Probably don't need to cast this just to read m_iDeaths
		CBasePlayer *plr = (CBasePlayer *)UTIL_PlayerByIndex( i );

		if ( plr )
		{
			MESSAGE_BEGIN( MSG_ONE, gmsgScoreInfo, NULL, pPlayer->edict() );
				WRITE_BYTE( i );	// client number
				WRITE_SHORT( plr->pev->frags );
				WRITE_SHORT( plr->m_iDeaths );
			MESSAGE_END();
		}
	}

	//
	// If the game is over, send the intermission message
	//

	if ( g_fGameOver )
	{
		MESSAGE_BEGIN( MSG_ONE, SVC_INTERMISSION, NULL, pPlayer->edict() );
		MESSAGE_END();
	}

	//
	// Display to the user what team he is one
	//

	if (pPlayer ->m_nTeam != CBasePlayer::Team_Menu)
	{
		char text[1024];
		char *mdls = g_engfuncs.pfnInfoKeyValue( g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), "model" );
		if ( !strcmp( mdls, pPlayer->m_szTeamName ) )
		{
			sprintf( text, "* you are on the \'%s\' team\n", pPlayer->m_szTeamName );
		}
		else
		{
			sprintf( text, "* assigned to the \'%s\' team\n", pPlayer->m_szTeamName );
		}
		UTIL_SayText( text, pPlayer );
	}

	//
	// Change to that team
	//

	ChangePlayerTeam( pPlayer, pPlayer->m_szTeamName, FALSE, FALSE );

	//
	// Get the client index of the player
	//

	int clientIndex = pPlayer->entindex();

	//
	// Send the teams
	//

	MESSAGE_BEGIN (MSG_ONE, gmsgJTeamList, NULL, pPlayer ->edict ());
		WRITE_BYTE (1 + gm_iNumTeams);
		for ( i = 0; i < gm_iNumTeams; i++)
			WRITE_STRING (GetIndexedTeamName (i));
		WRITE_STRING (s_pszObserverTeam);
	MESSAGE_END();
	if (scorestyle .value == 1)
	{
		for (i = 0; i < gm_iNumTeams; i++)
		{
			MESSAGE_BEGIN (MSG_ONE, gmsgJTeamScore, NULL, pPlayer ->edict ());
				WRITE_BYTE (i);
				WRITE_SHORT (gm_iTeamScores [i]);
			MESSAGE_END();
		}
	}

	// update this player with all the other players team info
	// loop through all active players and send their team info to the new client
	if (gmsgJTeamInfo)
	{
		for ( int i = 1; i <= gpGlobals->maxClients; i++ )
		{
			CBaseEntity *plr = UTIL_PlayerByIndex( i );
			if ( plr )
			{
				CBasePlayer *p = (CBasePlayer *) plr;
				if (p ->m_nTeam != CBasePlayer::Team_Disconnected)
				{
					MESSAGE_BEGIN( MSG_ONE, gmsgJTeamInfo, NULL, pPlayer->edict() );
						WRITE_BYTE( plr->entindex() );
						WRITE_BYTE( p->m_nTeam );
					MESSAGE_END();
					if (p ->m_nJail != CBasePlayer::Jail_Free)
					{
						MESSAGE_BEGIN (MSG_ONE, gmsgJInJail, NULL, pPlayer->edict() );
							WRITE_BYTE( plr->entindex() );
							WRITE_BYTE( p ->m_nJail != CBasePlayer::Jail_Free );
						MESSAGE_END ();
					}
					if (p ->m_nArmory != CBasePlayer::Armory_Out)
					{
						MESSAGE_BEGIN (MSG_ONE, gmsgJInArmory, NULL, pPlayer->edict() );
							WRITE_BYTE (plr->entindex());
							WRITE_BYTE (p ->m_nArmory != CBasePlayer::Armory_Out);
						MESSAGE_END ();
					}
				}
			}
		}
	}
	
	//
	// If a vote is in progress, send vote status
	//

	if (gmsgJVoteStatus)
	{
		if (m_nVote != Vote_None)
		{
			MESSAGE_BEGIN (MSG_ONE, gmsgJVoteStatus, NULL, pPlayer ->edict () );
				WRITE_BYTE (1);
			MESSAGE_END ();
		}
	}

	//
	// Either display the select team menu, or display the MOTD text
	//

	if (pPlayer ->m_nTeam == CBasePlayer::Team_Menu) 
	{
		DisplaySelectTeamMenu (pPlayer, TRUE);
		pPlayer ->m_nNextTeam = CBasePlayer::Team_Observe;
		pPlayer ->m_nTeam = CBasePlayer::Team_Observe;
	}
	else
	{
		if (pPlayer ->m_fFirstTeam)
		{
			pPlayer ->m_fShowMOTD = TRUE;
			pPlayer ->m_fFirstTeam = FALSE;
		}
	}
}
	
//=========================================================
// SetDefaultPlayerTeam
//=========================================================

const char *CJailBreakTeamplay::SetDefaultPlayerTeam (CBasePlayer *pPlayer)
{
	int nTeam;

	//
	// Get the default team number
	//

	if (teamforce .value) 
	{
		nTeam = TeamWithFewestPlayers (pPlayer);
		pPlayer ->m_nTeam = (CBasePlayer::_Team) nTeam;
	}
	else
	{
		nTeam = pPlayer ->m_nTeam;
	}
	
	//
	// Get the name for the team
	//

	const char *pszTeamName;
	if (nTeam >= 0)
	{
		pszTeamName = GetIndexedTeamName (nTeam);
	}
	else
	{
		pszTeamName = s_pszObserverTeam;
	}

	//
	// Copy the name
	//

	strncpy (pPlayer ->m_szTeamName, pszTeamName, TEAM_NAME_LENGTH);

	//
	// Return the name
	//

	return pPlayer ->m_szTeamName;
}

//=========================================================
// ClientUserInfoChanged
//=========================================================

void CJailBreakTeamplay::ClientUserInfoChanged( CBasePlayer *pPlayer, char *infobuffer )
{
	char *psz;

	//
	// Prevent skin/color/model changes
	//

	psz = g_engfuncs.pfnInfoKeyValue( infobuffer, "model" );
	if (stricmp ( psz, pPlayer ->m_szModelName)) 
	{
		g_engfuncs.pfnSetClientKeyValue( pPlayer->entindex(), 
			g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), 
			"model", pPlayer ->m_szModelName );
//		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
//			UTIL_VarArgs("* Not allowed to change models in this game!\n"));
		return;
	}

	//
	// Prevent topcolor changes
	//

	psz = g_engfuncs.pfnInfoKeyValue( infobuffer, "topcolor" );
	if (atol (psz) != pPlayer ->m_nColor)
	{
		SetPlayerColor (pPlayer, -1);
//		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
//			UTIL_VarArgs("* Not allowed to change top or bottom color in this game!\n"));
	}

	//
	// Prevent bottomcolor changes
	//

	psz = g_engfuncs.pfnInfoKeyValue( infobuffer, "bottomcolor" );
	if (atol (psz) != pPlayer ->m_nColor)
	{
		SetPlayerColor (pPlayer, -1);
//		ClientPrint ( pPlayer->pev, HUD_PRINTCONSOLE, 
//			UTIL_VarArgs("* Not allowed to change top or bottom color in this game!\n"));
	}

}

//=========================================================
// KillPlayer
//=========================================================

void CJailBreakTeamplay::KillPlayer (CBasePlayer *pPlayer, BOOL bGib)
{
	// kill the player,  remove a death,  and let them start on the new team
	m_DisableDeathMessages = TRUE;
	m_DisableDeathPenalty = TRUE;

	entvars_t *pevWorld = VARS( INDEXENT(0) );
	pPlayer ->pev ->health = 0;
	pPlayer ->Killed (pevWorld, bGib ? GIB_ALWAYS : GIB_NEVER);

	m_DisableDeathMessages = FALSE;
	m_DisableDeathPenalty = FALSE;
}

//=========================================================
// ChangePlayerTeam
//=========================================================

void CJailBreakTeamplay::ChangePlayerTeam( CBasePlayer *pPlayer, const char *pTeamName, BOOL bKill, BOOL bGib )
{
	int clientIndex = pPlayer->entindex();

	if ( bKill )
		KillPlayer (pPlayer, bGib);

	// copy out the team name from the model
	strncpy( pPlayer->m_szTeamName, pTeamName, TEAM_NAME_LENGTH );

	// set the model based on the team name
	if (strcmp (pPlayer ->m_szTeamName, s_pszObserverTeam) == 0)
	{
		strncpy( pPlayer->m_szModelName, GetIndexedTeamName (0), TEAM_NAME_LENGTH );
	} 
	else 
	{
		strncpy( pPlayer->m_szModelName, pTeamName, TEAM_NAME_LENGTH );
	}

	g_engfuncs.pfnSetClientKeyValue( clientIndex, g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), "model", pPlayer->m_szModelName );
	g_engfuncs.pfnSetClientKeyValue( clientIndex, g_engfuncs.pfnGetInfoKeyBuffer( pPlayer->edict() ), "team", pPlayer->m_szTeamName );

	// notify everyone's HUD of the team change
	if (gmsgJTeamInfo)
	{
		MESSAGE_BEGIN( MSG_ALL, gmsgJTeamInfo );
			WRITE_BYTE( clientIndex );
			WRITE_BYTE( pPlayer->m_nNextTeam );
		MESSAGE_END();
	}

	// Zero his score
	
	pPlayer ->pev ->frags = 0;
	pPlayer ->m_iDeaths = 0;
	MESSAGE_BEGIN( MSG_ALL, gmsgScoreInfo );
		WRITE_BYTE( ENTINDEX(pPlayer->edict()) );
		WRITE_SHORT( pPlayer->pev->frags );
		WRITE_SHORT( pPlayer->m_iDeaths );
	MESSAGE_END();
}

//=========================================================
// SayPlay
//=========================================================

void CJailBreakTeamplay::SayPlay (CBasePlayer *pClient, BOOL fRadio, BOOL fTeam, 
	BOOL fClose, const char *pszSound, const char *pszMessage)
{
	char szText [2048];

	//
	// Adjust the message to make sure something is printed
	//

	if (!pszMessage || !pszMessage [0])
	{
		if (fRadio)
		{
			pszMessage = pszSound ? pszSound : "no sound specified";
		}
		else
		{
			pszMessage = "";
		}
	}

	//
	// Generate the fully text of the message (the 2 at the
	// start turns on color set 2 which turns off sound.)
	//

	char *pszYell = fClose ? " (yelled)" : "";
	if (fTeam)
	{
		_snprintf (szText, sizeof (szText), "%c(TEAM)%s%s: %s", 
		    2, STRING (pClient ->pev ->netname), pszYell, pszMessage);
	}
	else
	{
		_snprintf (szText, sizeof (szText), "%c%s%s: %s", 
		    2, STRING (pClient ->pev ->netname), pszYell, pszMessage);
	}

	//
	// don't let text be too long for malicious reasons
	//

	if (strlen (szText) > 150)
		szText [150] = 0;

	//
	// Make sure the text ends with a return
	//

	strcat (szText, "\n");

	//
	// Test for flooding
	//

	if (floodmsgs .value) {

        if (gpGlobals->time < pClient ->m_fFloodLockTill) {
			ClientPrint (pClient ->pev, HUD_PRINTCONSOLE, 
				UTIL_VarArgs ("You can't talk or radio for %d more seconds\n", 
				(int)(pClient ->m_fFloodLockTill - gpGlobals->time)));
            return;
        }
		int nMax = (sizeof (pClient ->m_afFloodWhen) / 
			sizeof (pClient ->m_afFloodWhen [0]));
        int i = pClient ->m_nFloodWhenHead - floodmsgs .value + 1;
        if (i < 0) i = nMax + i;
		if (pClient ->m_afFloodWhen [i] && 
			gpGlobals->time - pClient ->m_afFloodWhen [i] < floodpersecond .value) {
			pClient ->m_fFloodLockTill = gpGlobals->time + floodwaitdelay .value;
			ClientPrint (pClient ->pev, HUD_PRINTCONSOLE, 
				UTIL_VarArgs ("Flood protection:  You can't talk or radio for %d seconds.\n", 
				(int)(floodwaitdelay .value)));
	            return;
        }
		pClient ->m_nFloodWhenHead = (pClient ->m_nFloodWhenHead + 1) % nMax;
		pClient ->m_afFloodWhen [pClient ->m_nFloodWhenHead] = gpGlobals->time;
	}

	//
	// Add message to the log
	//

	g_engfuncs .pfnServerPrint (szText);

	// loop through all players
	// Start with the first player.
	// This may return the world in single player if the client types something between levels or during spawn
	// so check it, or it will infinite loop

	CBasePlayer *pOther = NULL;
	while ( ((pOther = (CBasePlayer*) UTIL_FindEntityByClassname (
		pOther, "player" )) != NULL) && (!FNullEnt(pOther->edict())) ) 
	{

		//
		// Skip if not data structure
		//

		if (!pOther->pev)
			continue;
		
		//
		// Not a client ? (should never be true)
		//

		if ( !(pOther->IsNetClient()) )
			continue;

		//
		// Check player relationship
		//

		BOOL fSameTeam = g_pGameRules ->PlayerRelationship (
			pOther, pClient) == GR_TEAMMATE;

		if (fTeam && !fSameTeam)
			continue;

		//
		// Next check proximity
		//

		if (fClose)
		{
			vec3_t vDist = pOther ->pev ->origin - pClient ->pev ->origin;
			if (vDist .Length () > 512) //FIXME make server config
				continue;
		}

		//
		// Now if this is a radio and we don't want 
		// opponents, skip
		//

		if (fRadio && !fSameTeam && 
			(pOther ->m_nRadioFlags & CBasePlayer::Radio_Opponents_Off) != 0) 
			continue;

		//
		// Play the sound if required
		//
		// Note: I tried creating a client message to issue the PlaySound
		// method from the client.  The problem is that PlaySound seems
		// to be only one channel wide.
		//

		if (fRadio && pszSound && pszSound [0] && 
			(pOther ->m_nRadioFlags & CBasePlayer::Radio_Sound_Off) == 0) {
			CLIENT_COMMAND (pOther ->edict (), "play %s\n", pszSound);
		}

		//
		// Display the text if required
		//

		if (!fRadio || (pOther ->m_nRadioFlags & 
			CBasePlayer::Radio_Text_Off) == 0) {
			UTIL_SayText (szText, pOther);
		}
	}
}

//=========================================================
// Think
//=========================================================

void CJailBreakTeamplay :: Think ( void )
{
	//
	// If the game is already over, then skip
	//

	if ( g_fGameOver )
	{
		CHalfLifeMultiplay::Think();
		return;
	}

	//
	// Check the time limit
	//

	float flTimeLimit = CVAR_GET_FLOAT(timelimit .name) * 60;
	if ( flTimeLimit != 0 && gpGlobals->time >= flTimeLimit )
	{
		GoToIntermission();
		return;
	}

	//
	// Total scores and such
	//

	struct {
		int players;
		int frags;
		int injail;
	} anTeamScores [MAX_TEAMS];
	memset (anTeamScores, 0, sizeof (anTeamScores [0]) * gm_iNumTeams);
	for ( int i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBasePlayer *pPlayer = (CBasePlayer *) UTIL_PlayerByIndex( i );
		if ( pPlayer && pPlayer ->m_nTeam >= 0)
		{	
			int nTeam = pPlayer ->m_nTeam;
			anTeamScores [nTeam] .players++;
			anTeamScores [nTeam] .frags += pPlayer ->pev ->frags;
			if (pPlayer ->m_nJail == CBasePlayer::Jail_In)
				anTeamScores [nTeam] .injail++;
		}
	}


	//
	// Check for a team frag limit
	//

	float flFragLimit = fraglimit.value;
	if ( flFragLimit )
	{
		if (scorestyle .value == 1)
		{
			for ( i = 0; i < gm_iNumTeams; i++)
			{
				if (gm_iTeamScores [i] >= flFragLimit)
				{
					GoToIntermission();
					return;
				}
			}
		}
		else
		{
			for ( i = 0; i < gm_iNumTeams; i++)
			{
				if (anTeamScores [i] .frags >= flFragLimit)
				{
					GoToIntermission();
					return;
				}
			}
		}
	}

	//
	// If it is time to check for executions
	//

	if (gpGlobals ->time > m_fExecCheckTime)
	{

		//
		// Check for full jail
		//

		for ( i = 0; i < gm_iNumTeams; i++)
		{
			if (anTeamScores [i] .players > 0 &&
				anTeamScores [i] .injail >= 
				anTeamScores [i] .players)
			{
				ExecuteTeam (i);
			}
		}

		//
		// Update the check timer (every 5 seconds)
		//

		m_fExecCheckTime = gpGlobals ->time + 5.0f;
	}

	//
	// If a vote is in progress
	//

	if (m_nVote != Vote_None)
	{

		//
		// Count the votes
		//

		int nCount = 0;
		int nYes = 0;
		int nNo = 0;
		int nHasnt = 0;
		for ( int i = 1; i <= gpGlobals->maxClients; i++ )
		{
			CBasePlayer *pPlayer = (CBasePlayer *) UTIL_PlayerByIndex( i );
			if ( pPlayer && pPlayer ->m_nTeam != CBasePlayer::Team_Disconnected)
			{	
				nCount++;
				if (pPlayer ->m_nVote == CBasePlayer::Vote_Yes)
					nYes++;
				else if (pPlayer ->m_nVote == CBasePlayer::Vote_No)
					nNo++;
				else
					nHasnt++;
			}
		}

		//
		// If the vote has passed or time has run out
		//

		if (nHasnt == 0 || m_fVoteEndTime < gpGlobals ->time)
		{
			_Vote nVote = m_nVote;

			//
			// Cancel the vote flag
			//

			m_nVote = Vote_None;

			//
			// Reset the HUDs
			//

			MESSAGE_BEGIN (MSG_ALL, gmsgJVoteStatus);
				WRITE_BYTE (0);
			MESSAGE_END ();

			//
			// Collect information about the vote type
			//

			float fPercent = 100;
			char szText [256];
			const char *pszName;
			BOOL fAddText;

			if (nVote == Vote_Map)
			{
				fPercent = CVAR_GET_FLOAT (votemap .name);
				pszName = "change map to";
				fAddText = TRUE;
			}
			else
			{
				fPercent = 999;
				pszName = "???";
				fAddText = FALSE;
			}

			//
			// Test for passing
			//

			BOOL fPassed = fPercent <= (100.0 * (float) (nYes) / (float) (nCount));

			//
			// Generate the results string
			//

			if (fAddText)
			{
				sprintf (szText, "* Vote to %s %s %s, Y:%d N:%d A:%d\n",
					pszName, m_szVoteText, fPassed ? "passed" : "failed",
					nYes, nNo, nHasnt);
			}
			else
			{
				sprintf (szText, "* Vote to %s %s, Y:%d N:%d A:%d\n",
					pszName, fPassed ? "passed" : "failed",
					nYes, nNo, nHasnt);
			}

			UTIL_SayTextAll (szText, CBaseEntity::Instance (NULL));

			//
			// Perform the action
			//

			if (fPassed) 
			{
				if (nVote == Vote_Map)
				{
					sprintf (szText, "changelevel %s\n",
						m_szVoteText);
					SERVER_COMMAND (szText);
				}
			}
		}
	}
}

//=========================================================
// ExecuteTeam
//=========================================================

extern float gfExecuteDelay;
extern BOOL gfExecuteNoGib;
extern BOOL gfExecuteNoSound;

void CJailBreakTeamplay :: ExecuteTeam ( int nTeam )
{
	char szText [128];
	float fOffsetTime = 0.0;
	BOOL fNoGib = FALSE;
	BOOL fNoSound = FALSE;
	int nCount = 0;

	//
	// Issue the message
	//

	sprintf (szText, "* %s team EXECUTED!\n",
		GetIndexedTeamName (nTeam));
	MESSAGE_BEGIN( MSG_ALL, gmsgSayText, NULL );
		WRITE_BYTE( 0 ); //world
		WRITE_STRING( szText );
	MESSAGE_END();

	//
	// Locate the first player
	//

	CBasePlayer *client = NULL;
	while ( ((client = (CBasePlayer*) UTIL_FindEntityByClassname
		( client, "player" )) != NULL) && (!FNullEnt (client ->edict ()))) 
	{

		//
		// Make sure this is a good player on the proper team
		//

		if ( !client->pev )
			continue;
		
		if ( !(client->IsNetClient()) )	// Not a client ? (should never be true)
			continue;

		if (nTeam != client ->m_nTeam) 
			continue;

		//
		// Got somone
		//

		break;
	}

	//
	// Trigger the execution entities
	//

	if (client != NULL && !FNullEnt (client ->edict ()))
	{
		CBaseEntity *pWorld = CBaseEntity::Instance (NULL);
		CBaseEntity *pExec = NULL;
		while (((pExec = UTIL_FindEntityByClassname (
			pExec, "jail_execute" )) != NULL) && (!FNullEnt (pExec ->edict ())))
		{
			if (pExec ->IsTriggered (client))
			{
				pExec ->Use (pWorld, pWorld, USE_ON, 0);
				fOffsetTime = gfExecuteDelay;
				fNoGib = gfExecuteNoGib;
				fNoSound = gfExecuteNoSound;
			}
		}
	}

	//
	// Loop through the clients
	//

	client = NULL;
	while ( ((client = (CBasePlayer*) UTIL_FindEntityByClassname
		( client, "player" )) != NULL) && (!FNullEnt (client ->edict ()))) 
	{
		//
		// Make sure this is a good player on the proper team
		//

		if ( !client->pev )
			continue;
		
		if ( !(client->IsNetClient()) )	// Not a client ? (should never be true)
			continue;

		if (nTeam != client ->m_nTeam) 
			continue;

		//
		// Set the flags
		//

		client ->m_fSpawnInJail = FALSE;
		client ->m_nJail = CBasePlayer::Jail_DeathRow;
		client ->m_fEventTime = gpGlobals ->time + fOffsetTime + RANDOM_FLOAT( 0.0, 2.0 );
		client ->m_fExecuteNoGib = fNoGib;
		nCount++;
	}

	//
	// Add the score to the other players
	//

	client = NULL;
	while ( ((client = (CBasePlayer*) UTIL_FindEntityByClassname
		( client, "player" )) != NULL) && (!FNullEnt (client ->edict ()))) 
	{
		//
		// Make sure this is a good player on the proper team
		//

		if ( !client->pev )
			continue;
		
		if ( !(client->IsNetClient()) )	// Not a client ? (should never be true)
			continue;

		if (nTeam == client ->m_nTeam || client ->m_nTeam < 0) 
			continue;

		//
		// Add the points
		//

		if (scorestyle .value == 0) 
			client ->AddPoints (nCount, TRUE);

		//
		// If not in jail, respawn
		//

		if (client ->m_nJail == CBasePlayer::Jail_Free)
		{
		    GetPlayerSpawnSpot (client);
		}
	}

	//
	// Add team scores
	//

	if (scorestyle .value == 1)
	{
		for (int i = 0; i < gm_iNumTeams; i++)
		{
			if (i != nTeam)
			{
				gm_iTeamScores [i]++;
				MESSAGE_BEGIN (MSG_ALL, gmsgJTeamScore);
					WRITE_BYTE (i);
					WRITE_SHORT (gm_iTeamScores [i]);
				MESSAGE_END();
			}
		}
	}

	//
	// Generate the execution sound
	//

	if (!fNoSound)
	{
		sprintf (szText, "misc/execute%d.wav", nTeam + 1);
		Vector origin (0, 0, 0);
		UTIL_EmitAmbientSound ( ENT(0), origin, szText, 
			1.0, ATTN_NONE, 0, PITCH_NORM);
	}
	return;
}

//=========================================================
// FPlayerCanTakeDamage
//=========================================================

BOOL CJailBreakTeamplay::FPlayerCanTakeDamage( CBasePlayer *pPlayer, CBaseEntity *pAttacker )
{

	//
	// Test for friendly fire
	//

	if ( pAttacker && PlayerRelationship( pPlayer, pAttacker ) == GR_TEAMMATE )
	{
		// my teammate hit me.
		if ( (CVAR_GET_FLOAT(friendlyfire .name) == 0) && (pAttacker != pPlayer) )
		{
			// friendly fire is off, and this hit came from someone other than myself,  then don't get hurt
			return FALSE;
		}

		//
		// Test for friendly in jail
		//

		if (pPlayer ->m_nTeam == ((CBasePlayer *) pAttacker) ->m_nTeam && 
			pPlayer ->m_nJail == CBasePlayer::Jail_In)
		{
			return FALSE;
		}
	}

	//
	// Test for either player a death row inmate
	//

	if (pAttacker && pAttacker ->IsPlayer () && pPlayer ->IsPlayer ())
	{
		CBasePlayer *pAtt = (CBasePlayer *) pAttacker;
		if (pAtt ->m_nJail == CBasePlayer::Jail_DeathRow ||
			pPlayer ->m_nJail == CBasePlayer::Jail_DeathRow)
			return FALSE;
	}

	//
	// Default to multiplay
	//

	return CHalfLifeMultiplay::FPlayerCanTakeDamage( pPlayer, pAttacker );
}

//=========================================================
// TeamWithFewestPlayers
//=========================================================

int CJailBreakTeamplay::TeamWithFewestPlayers( CBasePlayer *pSkip )
{
	int i;
	int minPlayers = MAX_TEAMS;
	int teamCount[ MAX_TEAMS ];

	memset( teamCount, 0, MAX_TEAMS * sizeof(int) );
	
	// loop through all clients, count number of players on each team
	for ( i = 1; i <= gpGlobals->maxClients; i++ )
	{
		CBaseEntity *plr = UTIL_PlayerByIndex( i );

		if ( plr && plr != pSkip)
		{
			CBasePlayer *pPlayer = (CBasePlayer *) plr;
			if ( pPlayer ->m_nTeam >= 0 )
				teamCount[pPlayer ->m_nTeam] ++;
		}
	}

	// Find team with least players
	int nTeam = 0;
	for ( i = 0; i < gm_iNumTeams; i++ )
	{
		if ( teamCount[i] < minPlayers )
		{
			minPlayers = teamCount[i];
		    nTeam = i;
		}
	}

	return nTeam;
}

//=========================================================
// GetTeamID
//=========================================================

const char *CJailBreakTeamplay::GetTeamID( CBaseEntity *pEntity )
{
	if ( pEntity == NULL || pEntity->pev == NULL )
		return "";

	// return their team name
	return pEntity->TeamID();
}

//=========================================================
// GetTeamIndex
//=========================================================

int CJailBreakTeamplay::GetTeamIndex( const char *pTeamName )
{
	if ( pTeamName && *pTeamName != 0 )
	{
		// try to find existing team
		for ( int tm = 0; tm < gm_iNumTeams; tm++ )
		{
			if ( !stricmp( team_names[tm], pTeamName ) )
				return tm;
		}
	}
	
	return -1;	// No match
}

//=========================================================
// GetIndexedTeamName
//=========================================================

const char *CJailBreakTeamplay::GetIndexedTeamName( int teamIndex )
{
	if ( teamIndex < 0 || teamIndex >= gm_iNumTeams )
		return "";

	return team_names[ teamIndex ];
}

//=========================================================
// IsValidTeam
//=========================================================

BOOL CJailBreakTeamplay::IsValidTeam( const char *pTeamName ) 
{
	return ( GetTeamIndex( pTeamName ) != -1 ) ? TRUE : FALSE;
}

//=========================================================
// PlayerRelationship
//=========================================================

int CJailBreakTeamplay::PlayerRelationship( CBaseEntity *pPlayer, CBaseEntity *pTarget )
{
	// half life multiplay has a simple concept of Player Relationships.
	// you are either on another player's team, or you are not.
	if ( !pPlayer || !pTarget || !pTarget->IsPlayer() )
		return GR_NOTTEAMMATE;

	if ( (*GetTeamID(pPlayer) != '\0') && (*GetTeamID(pTarget) != '\0') && !stricmp( GetTeamID(pPlayer), GetTeamID(pTarget) ) )
	{
		return GR_TEAMMATE;
	}

	return GR_NOTTEAMMATE;
}

//=========================================================
// ShouldAutoAim
//=========================================================

BOOL CJailBreakTeamplay::ShouldAutoAim( CBasePlayer *pPlayer, edict_t *target )
{
	// always autoaim, unless target is a teammate
	CBaseEntity *pTgt = CBaseEntity::Instance( target );
	if ( pTgt && pTgt->IsPlayer() )
	{
		if ( PlayerRelationship( pPlayer, pTgt ) == GR_TEAMMATE )
			return FALSE; // don't autoaim at teammates
	}

	return CHalfLifeMultiplay::ShouldAutoAim( pPlayer, target );
}

//=========================================================
// IPointsForKill
//=========================================================

int CJailBreakTeamplay::IPointsForKill( CBasePlayer *pAttacker, CBasePlayer *pKilled )
{
	if ( !pKilled )
		return 0;

	if ( !pAttacker )
		return 1;

	if ( pAttacker != pKilled && PlayerRelationship( pAttacker, pKilled ) == GR_TEAMMATE )
		return -1;

	if (pKilled ->m_nJail != CBasePlayer::Jail_Free)
		return -1;

	return 1;
}

//=========================================================
// Deathnotice. 
//=========================================================

void CJailBreakTeamplay::DeathNotice( CBasePlayer *pVictim, entvars_t *pKiller, entvars_t *pevInflictor )
{
	if ( m_DisableDeathMessages )
		return;
	
	//
	// If the victim is on deathrow, don't do anything
	//

	if (pVictim ->m_nJail == CBasePlayer::Jail_DeathRow)
		return;

	if ( pVictim && pKiller && pKiller->flags & FL_CLIENT )
	{
		CBasePlayer *pk = (CBasePlayer*) CBaseEntity::Instance( pKiller );

		if ( pk )
		{
			if ( (pk != pVictim) && (PlayerRelationship( pVictim, pk ) == GR_TEAMMATE) )
			{
				MESSAGE_BEGIN( MSG_ALL, gmsgDeathMsg );
					WRITE_BYTE( ENTINDEX(ENT(pKiller)) );		// the killer
					WRITE_BYTE( ENTINDEX(pVictim->edict()) );	// the victim
					WRITE_STRING( "teammate" );		// flag this as a teammate kill
				MESSAGE_END();
				return;
			}
		}
	}

	CHalfLifeMultiplay::DeathNotice( pVictim, pKiller, pevInflictor );
}

//=========================================================
// UpdateGameMode. 
//=========================================================

void CJailBreakTeamplay :: UpdateGameMode( CBasePlayer *pPlayer )
{
	MESSAGE_BEGIN( MSG_ONE, gmsgGameMode, NULL, pPlayer->edict() );
		WRITE_BYTE( 1 );  // game mode teamplay
	MESSAGE_END();
}

//=========================================================
// IsTeamplay
//=========================================================

BOOL CJailBreakTeamplay::IsTeamplay( void )
{
	return TRUE;
}

//=========================================================
// RecountTeams
//=========================================================

void CJailBreakTeamplay::ParseTeamString ( void )
{
	char	*pName;
	char	teamlist[TEAMPLAY_TEAMLISTLENGTH];

	// loop through all teams, recounting everything
	gm_iNumTeams = 0;

	// Copy all of the teams from the teamlist
	// make a copy because strtok is destructive
	strcpy( teamlist, m_szTeamList );
	pName = teamlist;
	pName = strtok( pName, ";" );
	while ( pName != NULL && *pName )
	{
		if ( GetTeamIndex( pName ) < 0 )
		{
			strcpy( team_names[gm_iNumTeams], pName );
			gm_iNumTeams++;
		}
		pName = strtok( NULL, ";" );
	}

	if ( gm_iNumTeams < 2 )
	{
		ALERT (at_console, "At least 2 teams are required\n");
	}
}

//=========================================================
// PlayerKilled
//=========================================================

void CJailBreakTeamplay :: PlayerKilled( CBasePlayer *pVictim, entvars_t *pKiller, entvars_t *pInflictor )
{
	if ( !m_DisableDeathPenalty )
	{
		CHalfLifeMultiplay::PlayerKilled( pVictim, pKiller, pInflictor );
	}
}
//=========================================================
// RadioMessage
//=========================================================

struct _Radio
{
	const char *pszSound;
	const char *pszMessage;
	BOOL fTeam;
	BOOL fYell;
};

static const _Radio s_aMessages [9] =
{
	{ "radio/radio1.wav", "We need guards at the jail!",			TRUE, FALSE },
	{ "radio/radio2.wav", "We need guards at the escape!",			TRUE, FALSE },
	{ "radio/radio3.wav", "Enemy inbound!",							TRUE, FALSE },
	{ "radio/radio4.wav", "Enemy inbound using atlernate passage!",	TRUE, FALSE },
	{ "radio/radio5.wav", "I'm going to free our prisoners",		TRUE, FALSE },
	{ "radio/radio6.wav", "I am attacking now!",					TRUE, FALSE },
	{ "radio/radio7.wav", "Enemy armory open!",						TRUE, FALSE },
	{ "radio/radio8.wav", "I need ammo.",							TRUE, FALSE },
	{ "radio/radio9.wav", "Hey you, help us escape!",				TRUE, TRUE },
};

void CJailBreakTeamplay::RadioMessage (CBasePlayer *pPlayer, int slot)
{
	BOOL fTeam = TRUE;
	const char *pszSound = NULL;
	const char *pszMessage = NULL;
	if (slot >= 1 && slot <= 9)
	{
		SayPlay (pPlayer, TRUE, 
			s_aMessages [slot - 1] .fTeam, 
			s_aMessages [slot - 1] .fYell, 
			s_aMessages [slot - 1] .pszSound, 
			s_aMessages [slot - 1] .pszMessage);
	}
}

//=========================================================
// ClientDisconnected
//=========================================================

void CJailBreakTeamplay :: ClientDisconnected( edict_t *pClient )
{
	//
	// Invoke base class
	//

	CHalfLifeMultiplay::ClientDisconnected (pClient);

	//
	// Mark the player as something other than a team member
	//

	if (pClient)
	{
		CBasePlayer *pPlayer = (CBasePlayer *)CBaseEntity::Instance( pClient );
		if ( pPlayer )
		{
			pPlayer ->m_nTeam = CBasePlayer::Team_Disconnected;
		}
	}
}

//=========================================================
// RefreshMapList
//=========================================================

void CJailBreakTeamplay :: RefreshMapList ( bool fRemoveDups )
{
	g_nMapCount = 0;

//	char szNextMap[32];
//	char szFirstMapInList[32];
//	strcpy( szFirstMapInList, "hldm1" );  // the absolute default level is hldm1
//	strcpy( szNextMap, STRING(gpGlobals->mapname) );
//	strcpy( szFirstMapInList, STRING(gpGlobals->mapname) );

	//
	// Get the name of the file
	//

	char *pszMapFile = (char*) CVAR_GET_STRING( "mapcyclefile" );
	ASSERT( pszMapFile != NULL );

	//
	// Load the file
	//

	int nLength;
	char *pFileList = (char *) LOAD_FILE_FOR_ME (pszMapFile, &nLength);

	//
	// If a file was found
	//

	if (pFileList && nLength)
	{

		//
		// Loop while there are lines
		//

		char *pFileCur = pFileList;
		while (nLength > 0)
		{

			//
			// Get the next line
			//

			char szLine [256];
			char *pszLine = szLine;
			while (nLength > 0 && *pFileCur != '\n')
			{
				char c = *pFileCur++;
				if (c > ' ' && c < 127) *pszLine++ = c;
				nLength--;
			}

			//
			// Remove the LF
			//

			if (nLength > 0)
			{
				nLength--;
				pFileCur++;
			}

			//
			// Terminate the line
			//

			*pszLine++ = 0;

			//
			// If there is anything in the line, add to map list
			//

			if (szLine [0] && IS_MAP_VALID (szLine))
			{
				if (fRemoveDups) 
				{
					for (int i = 0; i < g_nMapCount; i++)
					{
						if (FStrEq (g_aszMaps [i], szLine)) break;
					}
					if (i >= g_nMapCount)
					{
						strcpy (g_aszMaps [g_nMapCount++], szLine);
					}
				}
				else
				{
					strcpy (g_aszMaps [g_nMapCount++], szLine);
				}
			}
		}

		//
		// Free the file
		//

		FREE_FILE( pFileList );
	}

	//
	// If there were no files, use default
	//

	if (g_nMapCount == 0)
	{
		strcpy (g_aszMaps [g_nMapCount++], "hermercy");
	}
}

//=========================================================
// ChangeLevel
//=========================================================

void CJailBreakTeamplay :: ChangeLevel( void )
{
	char szMap [32];
	strcpy( szMap, STRING(gpGlobals->mapname) );

	//
	// Refresh the map list
	//

	RefreshMapList (false);

	//
	// If the last index is set, validate it
	//

	if (g_nMapLast >= 0)
	{
		if (g_nMapLast >= g_nMapCount)
		{
			g_nMapLast = -1;
		}
		else if (!FStrEq (g_aszMaps [g_nMapLast], szMap))
		{
			g_nMapLast = -1;
		}
	}

	//
	// If we have an index, move to the next map
	//

	int i;
	if (g_nMapLast >= 0)
	{
		i = g_nMapLast + 1;
	}

	//
	// Otherwise, find a map
	//

	else 
	{
		//
		// Loop through the map list looking for the current one
		//

		for (i = 0; i < g_nMapCount; i++) {
			if (FStrEq (szMap, g_aszMaps [i])) break;
		}
	}

	//
	// If the map was not found, use first
	//

	if (i >= g_nMapCount) 
		i = 0;

	//
	// Save index
	//

	g_nMapLast = i;

	//
	// Get the map name
	//

	strcpy (szMap, g_aszMaps [i]);

	//
	// Mark the game as over
	//

	g_fGameOver = TRUE;

	//
	// Change levels
	//
	
	ALERT( at_console, "CHANGE LEVEL: %s\n", szMap );
	CHANGE_LEVEL( szMap, NULL );
}

